#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 31 "moc.y"
void yyerror( char *msg );

#include "qlist.h"
#include "qstring.h"
#include "qdatetime.h"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

RCSTAG("$Id: moc.y,v 2.25 1998/07/06 19:22:17 hanord Exp $");

static QString rmWS( const char * );

enum AccessPerm { _PRIVATE, _PROTECTED, _PUBLIC };


struct Argument					/* single arg meta data*/
{
    Argument( char *left, char *right )
	{ leftType  = rmWS( left );
	  rightType = rmWS( right );
	  if ( leftType == "void" && rightType.isEmpty() )
	      leftType = "";
	}
    QString leftType;
    QString rightType;
};

Q_DECLARE(QListM,Argument);

class ArgList : public QListM(Argument) {	/* member function arg list*/
public:
    ArgList() { setAutoDelete(TRUE); }
};


struct Function					/* member function meta data*/
{						/*   used for signals and slots*/
    AccessPerm accessPerm;
    QString    qualifier;			/* const or volatile*/
    QString    name;
    QString    type;
    int	       lineNo;
    ArgList   *args;
    Function() { args=0; }
   ~Function() { delete args; }
};

Q_DECLARE(QListM,Function);

class FuncList : public QListM(Function) {	/* list of member functions*/
public:
    FuncList() { setAutoDelete(TRUE); }
};


ArgList *addArg( Argument * );			/* add arg to tmpArgList*/
void	 addMember( char );			/* add tmpFunc to current class*/

char	*strnew( const char * );		/* returns a new string (copy)*/
char	*stradd( const char *, const char * );	/* add two strings*/
char	*stradd( const char *, const char *,	/* add three strings*/
			       const char * );
char	*straddSpc( const char *, const char * );
char	*straddSpc( const char *, const char *,
			       const char * );
char	*straddSpc( const char *, const char *,
		    const char *, const char * );

extern int yydebug;
bool	   lexDebug	   = FALSE;
bool	   grammarDebug	   = FALSE;
int	   lineNo;				/* current line number*/
bool	   errorControl	   = FALSE;		/* controlled errors*/
bool	   displayWarnings = TRUE;
bool	   skipClass;				/* don't generate for class*/
bool	   skipFunc;				/* don't generate for func*/
bool	   templateClass;			/* class is a template*/

ArgList	  *tmpArgList;				/* current argument list*/
Function  *tmpFunc;				/* current member function*/
AccessPerm tmpAccessPerm;			/* current access permission*/
AccessPerm subClassPerm;			/* current access permission*/
bool	   Q_OBJECTdetected;			/* TRUE if current class*/
						/* contains the Q_OBJECT macro*/
QString	   tmpExpression;

const int  formatRevision = 2;			/* moc output format revision*/

#line 123 "moc.y"
typedef union {
    char	char_val;
    int		int_val;
    double	double_val;
    char       *string;
    AccessPerm	access;
    Function   *function;
    ArgList    *arg_list;
    Argument   *arg;
} YYSTYPE;
#line 113 "y.tab.c"
#define CHAR_VAL 257
#define INT_VAL 258
#define DOUBLE_VAL 259
#define STRING 260
#define IDENTIFIER 261
#define FRIEND 262
#define TYPEDEF 263
#define AUTO 264
#define REGISTER 265
#define STATIC 266
#define EXTERN 267
#define INLINE 268
#define VIRTUAL 269
#define CONST 270
#define VOLATILE 271
#define CHAR 272
#define SHORT 273
#define INT 274
#define LONG 275
#define SIGNED 276
#define UNSIGNED 277
#define FLOAT 278
#define DOUBLE 279
#define VOID 280
#define ENUM 281
#define CLASS 282
#define STRUCT 283
#define UNION 284
#define ASM 285
#define PRIVATE 286
#define PROTECTED 287
#define PUBLIC 288
#define OPERATOR 289
#define DBL_COLON 290
#define TRIPLE_DOT 291
#define TEMPLATE 292
#define SIGNALS 293
#define SLOTS 294
#define Q_OBJECT 295
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   38,   36,    1,    1,    2,   39,   40,   28,
   28,   28,   28,   28,   27,   29,   29,   30,   30,   41,
   41,   41,   41,   42,   42,   31,   31,   11,   11,   11,
   12,   12,   13,   13,   13,   13,   13,   13,   13,   13,
   13,    3,   43,   43,   14,   14,   15,   15,   16,   16,
   17,   17,   17,   18,   18,   20,   20,   44,   44,   19,
   19,   23,   45,   23,   23,   47,   23,   21,   21,   22,
   48,   22,   49,   22,   22,   22,   32,   32,   50,   32,
   32,   46,   51,   10,   10,   54,   10,   55,   10,   56,
   53,   57,   53,   35,   35,   34,   34,   33,   33,   24,
   24,   25,   25,   26,   26,   52,   52,   52,   59,   58,
   62,   37,   37,   37,   37,   63,   63,   63,   63,   63,
   64,   60,    4,    4,   61,   61,   65,   65,   67,   67,
   69,   66,   70,   66,   66,   68,   68,   73,   68,   68,
   71,   71,   74,   74,   75,   72,   72,   77,   77,   78,
   79,   79,    5,    6,    6,    7,    7,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    9,    9,    9,
   80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
   80,   81,   81,   82,   82,   82,   82,   82,   82,   82,
   82,   82,   82,   82,   82,   76,   76,   76,   76,   84,
   84,   86,   87,   86,   88,   86,   83,   89,   83,   91,
   85,   90,   90,
};
short yylen[] = {                                         2,
    0,    2,    0,    3,    1,    1,    4,    0,    0,    1,
    1,    1,    1,    1,    3,    0,    1,    1,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    4,    0,    1,    2,    2,    1,    2,    3,    1,
    2,    2,    2,    2,    3,    0,    1,    0,    1,    3,
    1,    2,    0,    5,    4,    0,    7,    0,    1,    2,
    0,    4,    0,    5,    1,    3,    1,    2,    0,    5,
    3,    1,    5,    1,    2,    0,    4,    0,    5,    0,
    4,    0,    5,    0,    1,    1,    2,    2,    2,    0,
    1,    1,    2,    1,    1,    1,    1,    3,    0,    3,
    0,    5,    2,    5,    2,    1,    1,    1,    1,    1,
    0,    4,    0,    1,    0,    1,    2,    1,    1,    1,
    0,    3,    0,    4,    1,    2,    3,    0,    3,    1,
    0,    1,    2,    1,    1,    0,    1,    2,    1,    1,
    0,    2,    2,    3,    1,    4,    4,    1,    3,    2,
    3,    2,    1,    3,    2,    3,    2,    1,    1,    1,
    3,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    3,    3,    2,    2,    2,    2,    1,    3,    2,    2,
    2,    0,    1,    2,    1,    3,    5,    2,    3,    4,
    3,    2,    6,    4,    5,    3,    4,    6,    3,    1,
    3,    1,    0,    4,    0,    3,    0,    0,    3,    0,
    5,    0,    1,
};
short yydefred[] = {                                      1,
    3,    2,    0,    0,    0,    0,    0,    0,    0,    8,
  116,   20,   21,   22,   23,   24,   25,   26,   27,   33,
   34,   35,   36,   37,   38,   39,   40,   41,  117,  118,
  119,  120,  115,    0,    0,    6,    4,   45,   46,  111,
    0,    8,    0,    0,    0,   42,    0,    0,    0,  122,
  124,  168,  169,  170,  133,  130,  135,  129,    0,    0,
  128,  131,    7,  114,    0,    0,    0,   50,    0,  163,
  155,    0,  158,    0,    0,  112,  127,    0,    0,  165,
    0,  160,    0,    0,    0,  167,  162,    0,    0,  140,
    0,    0,  138,  132,    0,    0,  164,  159,  154,  166,
  161,   49,    0,   13,   14,    0,    0,    0,    0,   44,
  215,    0,    0,   32,    0,   29,   28,   18,    0,   11,
   10,   12,  134,    0,  144,  145,    0,    0,    0,  136,
    0,    0,  156,  157,   86,   90,    0,    0,    0,   53,
    0,    0,  207,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  222,    0,
    0,    0,    0,  214,    0,   96,    0,   31,   51,    0,
    0,   19,  143,    0,    0,  238,  151,    0,  151,  137,
  150,    0,  149,  139,    9,    9,   88,   92,  240,    0,
  197,    0,  198,  196,  211,  210,  188,  192,  203,  186,
  205,    0,  187,  206,  189,  190,  191,  193,  204,  194,
  195,    0,    0,  221,  104,  105,   98,    0,  102,   99,
    0,    0,    0,  219,   97,   52,    0,  216,    0,    0,
    0,   61,    0,    0,    9,    0,  151,    0,    0,  148,
   87,    0,    9,    9,    0,  201,  202,  208,  171,  172,
  103,    0,  220,  224,    0,    0,    0,   59,   54,   71,
    0,    0,    0,   75,    0,  239,  152,    0,    0,    0,
  235,    0,   77,    0,  230,   91,   89,    0,  241,  225,
    0,  217,    0,   55,   60,    9,    0,   82,   63,    0,
   73,   70,   15,  233,    0,    9,   79,   78,  151,    0,
   93,  223,  106,    0,  109,   83,  107,    0,   76,    9,
    0,    9,    9,   81,  236,    9,    0,  231,    0,    0,
   72,   64,   66,    0,  234,    0,  108,  110,    9,   74,
   80,   67,
};
short yydgoto[] = {                                       1,
   68,   36,  110,   50,   51,   69,   70,   71,   58,  111,
  112,  113,  114,  115,  116,   74,  117,  229,  230,  231,
  262,  263,  232,  217,  218,  219,  233,  118,  157,  158,
  120,  272,  166,  221,  222,    2,    7,    3,   41,  241,
  121,  122,    8,  259,  310,  273,  329,  286,  312,  316,
  177,  306,  137,  185,  243,  186,  244,  307,  320,    9,
   59,   45,   33,   44,   60,   61,   62,   94,   78,   75,
  123,  180,  132,  124,  125,  181,  182,  183,  236,  159,
  127,  128,  178,  274,  129,  275,  313,  296,  235,  139,
  245,
};
short yysindex[] = {                                      0,
    0,    0, -279,  -36,  689, -234,   16, -128,   36,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  120,  148,    0,    0,    0,    0,    0,
  124,    0,  -34,  162,  532,    0,  170,  214,  563,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  166,  532,
    0,    0,    0,    0,  159,   72, -234,    0,  249,    0,
    0,  -87,    0,   44,  239,    0,    0,  -46,  606,    0,
 -246,    0,   44,  563, -246,    0,    0, -234,  627,    0,
  266,  270,    0,    0,  295,  303,    0,    0,    0,    0,
    0,    0,  133,    0,    0,    0,   69,   87,  419,    0,
    0,  180,  813,    0,   93,    0,    0,    0,  659,    0,
    0,    0,    0,  627,    0,    0,  240,  129,  319,    0,
  627,  627,    0,    0,    0,    0,  -20,    0,  267,    0,
  165,  222,    0,  330,  300,  364,  345,   34,  279,  439,
  363,  394,  399,  -41,  404,  409,  709,  808,    0,   82,
  419,  101,  101,    0,  252,    0,   21,    0,    0,  164,
  808,    0,    0,  210,  808,    0,    0,  288,    0,    0,
    0,  627,    0,    0,    0,    0,    0,    0,    0,  412,
    0,  413,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  384,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   35,   35,    0,    0,    0,    0,  101,    0,    0,
   35, -243,  419,    0,    0,    0,   35,    0,  434,  441,
  187,    0,   22,  585,    0,  433,    0,  -30,  433,    0,
    0,  405,    0,    0,  374,    0,    0,    0,    0,    0,
    0,  419,    0,    0, -203,  101,  466,    0,    0,    0,
   22,  -60,  -21,    0,  808,    0,    0,  433,  446,  -32,
    0,  130,    0,  293,    0,    0,    0,  414,    0,    0,
  419,    0,    8,    0,    0,    0,  308,    0,    0,   22,
    0,    0,    0,    0,  362,    0,    0,    0,    0,  -30,
    0,    0,    0,  247,    0,    0,    0,  415,    0,    0,
  445,    0,    0,    0,    0,    0,  433,    0,  450,  386,
    0,    0,    0,  438,    0,  440,    0,    0,    0,    0,
    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,  113,    0,  119,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   -4,   91,    0,    0,    0,    0,    0,
    0,    0,    0,  389,  401,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  402,
    0,    0,    0,    0,   66,    0,    0,    0,  416,    0,
    0,    0,    0,    7,    0,    0,    0,    0,    0,    0,
    0,    0,   38,    0,    0,    0,    0,    0,  200,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  118,    0,    0,  507,  417,    0,  718,    0,
    0,    0,   50,    0,    0,    0,    0,    0,  113,    0,
    0,    0,    0,  242,    0,    0,    0,  298,    0,    0,
  468,  468,    0,    0,    0,    0,  432,  169,    0,    0,
  494,  701,    0,  708,    0,    0,  789,  959,  961,  964,
  966,  969,  971,  991,  993,  996,    0,  -38,    0,  998,
  718,   74,   74,    0, -200,    0,    0,    0,    0,    0,
  -33,    0,    0,    0,  137,    0,    0,    0,    0,    0,
    0,  548,    0,    0,    0,    0,    0,    0,    0, 1001,
    0, 1003,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1023,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1025, 1025,    0,    0,    0,    0,   62,    0,    0,
  108,    0,  718,    0,    0,    0, -200,    0,    0,  -10,
  491,    0,  -11,  113,    0,  297,    0,    0,  342,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  718,    0,    0,    0,   81,  531,    0,    0,    0,
    0,  -12,  103,    0,   84,    0,    0,  377,  158,    0,
    0,  333,    0,    0,    0,    0,    0,    0,    0,    0,
  718,    0,    0,    0,    0,    0,    0,    0,    0,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   -2,    0,    0,    0,    0,    0,  430,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
short yygindex[] = {                                      0,
   29,    0,  538,    0,    0,    0,  125,  458,  146,  121,
  -97,    0,   14,  541,  289,  479,    0,    0,    0,    0,
  258,  290,  292, -149,    0,  332,    0,   51, -119,  365,
  549,  287,  -82,  470,  -29,    0,    0,    0,  546,  558,
  590,  591,    0,    0,    0,  335,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  539,    0,    0,    0,    0,
    0,  469,    0,    0,  474,   68,    0,  418, -163, -118,
    0,    0,    0,    0,    0,  302,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 1093
short yytable[] = {                                      17,
  289,   17,   17,   17,   16,   17,  218,  270,   16,  270,
  218,   93,    4,  220,   65,  239,  163,  160,   29,  208,
  162,  171,   17,   10,  218,  218,   34,  271,   62,   68,
   57,   62,   68,    5,   35,    5,    5,    5,   65,    5,
  187,   65,  214,   67,   47,  252,   47,   47,   47,   68,
   47,  227,   17,    5,    5,  234,    5,  160,  163,  163,
   94,  261,  162,  162,   47,   47,  303,   47,  304,  291,
  188,  199,  163,  268,   37,   48,  162,   48,   48,   48,
   68,   48,  209,   68,  225,  281,    5,   30,   94,   30,
   30,   30,   96,   30,  198,   48,   48,   47,   48,  101,
   68,  101,  101,  101,  254,  101,  283,   30,   30,    5,
   30,  100,  260,  100,  100,  100,  102,  100,    5,  101,
  101,   16,  101,   16,   16,   16,  168,   16,   48,   47,
  305,  100,  100,  280,  100,  317,  265,  234,  225,  100,
   30,  100,  135,   69,   16,  293,   69,   95,  121,  113,
  264,   95,  101,   38,   39,    5,  126,   84,   40,    5,
   48,   84,  302,   69,  100,   95,   95,  163,  175,  172,
  213,  162,  136,   65,   16,   84,   84,   56,  264,   42,
  292,   85,  249,  250,  101,   46,  176,   43,    5,  298,
   80,  126,   42,  135,   72,   82,   86,  255,   79,   82,
  288,   82,   67,  100,  292,   97,   52,  264,  172,  100,
   52,   81,  298,  121,   90,  172,   82,  163,   42,   49,
  297,  162,   17,  136,  190,  191,   48,   16,  288,   72,
  269,   63,  164,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   91,   92,   82,   68,
   17,   17,   17,   17,   64,   16,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   62,   68,
   57,  160,  193,  192,    5,    5,    5,  224,   65,  163,
   76,  243,   84,  162,  228,   47,   89,   47,   48,   48,
   48,   48,   48,   48,   48,   48,   48,   48,   48,  223,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,  201,  101,  130,  141,  212,   48,  131,   48,  138,
   68,  238,   65,   88,  100,  133,  300,   73,   30,  200,
   30,  237,  253,  134,   16,  163,  237,  140,  309,  162,
  101,  299,  101,  169,   82,    5,  237,   52,   53,   54,
   87,   67,  100,   69,  100,  174,  142,  212,   95,   98,
  215,  216,   73,  101,   16,  282,  232,  179,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,  189,
  194,  232,  195,   69,   43,   43,   95,   16,  291,  163,
   44,   44,  314,  162,  196,  197,    5,    5,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  226,  226,  205,  226,  248,   16,   56,   16,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
  160,  104,  105,   12,   13,   14,   15,   16,   17,   18,
   19,  156,  297,  119,  206,  152,  148,   52,  146,  207,
  147,  149,  143,  150,  210,  151,  229,  229,  161,  211,
  160,   85,  246,  247,  256,   85,  165,  258,  141,  144,
  142,   43,   43,  204,  257,  141,  141,  141,  119,   85,
   85,  267,  141,  141,  141,  119,  119,  276,  279,  203,
  202,  227,  227,  294,  319,  323,  301,  321,  327,  145,
  328,  123,  153,  104,  105,   12,   13,   14,   15,   16,
   17,   18,   19,   43,   43,  125,  126,  142,  142,  142,
  330,   58,  331,  184,  142,  142,  142,  184,  153,  242,
    5,   99,  154,    6,  155,   83,  119,  311,  285,  251,
  287,  184,  184,   30,  228,  228,  295,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  167,  226,  226,  226,  226,  226,   47,  226,  226,
  226,  226,  146,  212,   31,   32,  290,  173,   77,  240,
  184,  318,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,    0,  229,  229,  229,
  229,  229,  213,  229,  229,  229,  229,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,    0,  227,  227,  227,  227,  227,    0,  227,  227,
  227,  227,  147,  212,    0,    0,    0,    0,    0,    0,
  104,  105,   12,   13,   14,   15,   16,   17,   18,   19,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,    0,  228,  228,  228,  228,  228,
    0,  228,  228,  228,  228,    0,    0,  104,  105,   12,
   13,   14,   15,   16,   17,   18,   19,    0,    0,    0,
  185,    0,    0,  242,  185,    0,    0,  183,    0,   43,
   43,  183,    0,  146,  146,  146,  284,    0,  185,  185,
  146,  146,  146,    0,    0,  183,  183,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   16,  266,    0,    0,    0,   25,    0,   25,    0,
  277,  278,   16,   16,   16,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,    0,    0,   52,   53,   54,
   16,    0,   16,   65,   55,   56,   57,    0,  175,   43,
   43,   66,  175,  147,  147,  147,    0,    0,    0,    0,
  147,  147,  147,  308,    0,   34,  175,  175,   52,   53,
   54,    0,   67,  315,    0,    0,   20,   21,   22,   23,
   24,   25,   26,   27,   28,  170,   95,  322,  108,  324,
  325,    0,    0,  326,   67,    0,    4,   20,   21,   22,
   23,   24,   25,   26,   27,   28,  332,  103,  104,  105,
   12,   13,   14,   15,   16,  106,   18,   19,   20,   21,
   22,   23,   24,   25,   26,   27,   28,  107,    0,    0,
  108,    0,    0,    0,    0,  109,   67,    0,    4,   34,
  104,  105,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,  170,
    0,    0,  108,    0,    0,    0,    0,    0,   67,   11,
    4,    0,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,  212,
    0,    0,    0,    0,    0,    0,    0,    0,   16,    0,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   16,
   16,   16,   16,   16,   16,   16,   16,   16,  179,    0,
  173,    0,  179,  174,  173,  176,    0,  174,  177,  176,
  178,    0,  177,    0,  178,    0,  179,  179,  173,  173,
    0,  174,  174,  176,  176,    0,  177,  177,  178,  178,
  180,    0,  181,    0,  180,  182,  181,   84,    0,  182,
  199,   84,  200,    0,  199,    0,  200,    0,  180,  180,
  181,  181,    0,  182,  182,   84,   84,    0,  199,  199,
  200,  200,  209,    0,   94,    0,  209,    0,   94,  104,
  105,   12,   13,   14,   15,   16,   17,   18,   19,    0,
  209,  209,   94,   94,   20,   21,   22,   23,   24,   25,
   26,   27,   28,
};
short yycheck[] = {                                      38,
   61,   40,   41,   42,   38,   44,   40,   40,   42,   40,
   44,   58,  292,  163,  261,  179,   38,  261,    5,   61,
   42,  119,   61,   60,   58,   59,  261,   58,   41,   41,
   41,   44,   44,   38,    6,   40,   41,   42,   41,   44,
   61,   44,  161,  290,   38,  289,   40,   41,   42,   61,
   44,  171,   91,   58,   59,  175,   61,  261,   38,   38,
  261,   40,   42,   42,   58,   59,   59,   61,   61,   91,
   91,   38,   38,  237,   59,   38,   42,   40,   41,   42,
   41,   44,  124,   44,  167,  289,   91,   38,  289,   40,
   41,   42,   79,   44,   61,   58,   59,   91,   61,   38,
   61,   40,   41,   42,  223,   44,  256,   58,   59,   44,
   61,   38,   91,   40,   41,   42,   88,   44,  123,   58,
   59,   38,   61,   40,   41,   42,  113,   44,   91,  123,
  123,   58,   59,  252,   61,  299,  234,  257,  221,   59,
   91,   61,   61,   41,   61,  265,   44,   40,   58,   59,
  233,   44,   91,  282,  283,   38,   89,   40,  123,   42,
  123,   44,  281,   61,   91,   58,   59,   38,   40,  119,
  157,   42,   91,  261,   91,   58,   59,   41,  261,   60,
  263,  269,  212,  213,  123,   62,   58,   40,  123,  272,
   66,  124,   60,   61,   49,   38,   72,  227,   40,   42,
  261,   44,  290,  123,  287,   81,   38,  290,  158,   85,
   42,   66,  295,  123,  261,  165,   59,   38,   60,   58,
   91,   42,  261,   91,   60,   61,  261,  261,  261,   84,
  261,   62,  112,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  293,  294,   91,  261,
  289,  290,  291,  292,   41,  289,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  291,  291,
  291,  261,   61,   62,  289,  290,  291,  167,  291,   38,
  125,  123,   44,   42,  174,  289,   58,  291,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  289,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,   43,  261,   58,  125,  126,  289,   58,  291,  261,
  291,   44,  261,  290,  261,   41,   44,   49,  289,   61,
  291,   44,  222,   41,  261,   38,   59,  261,   41,   42,
  289,   59,  291,  261,   66,  290,   59,  286,  287,  288,
   72,  290,  289,  261,  291,  126,  125,  126,  261,   81,
  270,  271,   84,   85,  291,  255,   44,   59,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  123,
   61,   59,   93,  291,  282,  283,  289,  261,   91,   38,
  282,  283,   41,   42,   41,   61,  289,  290,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  125,  126,   61,  261,   42,  290,  291,  292,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,   33,   91,   89,   61,   37,   38,  289,   40,   61,
   42,   43,   44,   45,   61,   47,  125,  126,  289,   61,
  261,   40,   61,   61,   41,   44,  112,  291,   60,   61,
   62,  282,  283,   45,   44,  286,  287,  288,  124,   58,
   59,   59,  293,  294,  295,  131,  132,   93,  125,   61,
   62,  125,  126,   58,  258,   61,   93,   93,   59,   91,
  125,  123,   94,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  282,  283,  125,  125,  286,  287,  288,
   93,   41,   93,   40,  293,  294,  295,   44,  123,  123,
    3,   84,  124,    3,  126,   67,  182,  290,  257,  218,
  261,   58,   59,    5,  125,  126,  270,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  112,  286,  287,  288,  289,  290,   42,  292,  293,
  294,  295,  125,  126,    5,    5,  262,  124,   60,  182,
  132,  300,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,   -1,  286,  287,  288,
  289,  290,  126,  292,  293,  294,  295,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,   -1,  286,  287,  288,  289,  290,   -1,  292,  293,
  294,  295,  125,  126,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,   -1,  286,  287,  288,  289,  290,
   -1,  292,  293,  294,  295,   -1,   -1,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,   -1,   -1,   -1,
   40,   -1,   -1,  186,   44,   -1,   -1,   40,   -1,  282,
  283,   44,   -1,  286,  287,  288,  291,   -1,   58,   59,
  293,  294,  295,   -1,   -1,   58,   59,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  261,  235,   -1,   -1,   -1,  290,   -1,  292,   -1,
  243,  244,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,   -1,   -1,  286,  287,  288,
  290,   -1,  292,  261,  293,  294,  295,   -1,   40,  282,
  283,  269,   44,  286,  287,  288,   -1,   -1,   -1,   -1,
  293,  294,  295,  286,   -1,  261,   58,   59,  286,  287,
  288,   -1,  290,  296,   -1,   -1,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  261,  310,  284,  312,
  313,   -1,   -1,  316,  290,   -1,  292,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  329,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,   -1,   -1,
  284,   -1,   -1,   -1,   -1,  289,  290,   -1,  292,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,  290,  261,
  292,   -1,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  261,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  261,   -1,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  272,
  273,  274,  275,  276,  277,  278,  279,  280,   40,   -1,
   40,   -1,   44,   40,   44,   40,   -1,   44,   40,   44,
   40,   -1,   44,   -1,   44,   -1,   58,   59,   58,   59,
   -1,   58,   59,   58,   59,   -1,   58,   59,   58,   59,
   40,   -1,   40,   -1,   44,   40,   44,   40,   -1,   44,
   40,   44,   40,   -1,   44,   -1,   44,   -1,   58,   59,
   58,   59,   -1,   58,   59,   58,   59,   -1,   58,   59,
   58,   59,   40,   -1,   40,   -1,   44,   -1,   44,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,   -1,
   58,   59,   58,   59,  272,  273,  274,  275,  276,  277,
  278,  279,  280,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 295
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CHAR_VAL","INT_VAL",
"DOUBLE_VAL","STRING","IDENTIFIER","FRIEND","TYPEDEF","AUTO","REGISTER",
"STATIC","EXTERN","INLINE","VIRTUAL","CONST","VOLATILE","CHAR","SHORT","INT",
"LONG","SIGNED","UNSIGNED","FLOAT","DOUBLE","VOID","ENUM","CLASS","STRUCT",
"UNION","ASM","PRIVATE","PROTECTED","PUBLIC","OPERATOR","DBL_COLON",
"TRIPLE_DOT","TEMPLATE","SIGNALS","SLOTS","Q_OBJECT",
};
char *yyrule[] = {
"$accept : class_defs",
"class_defs :",
"class_defs : class_defs class_def",
"$$1 :",
"class_def : $$1 class_specifier ';'",
"class_name : IDENTIFIER",
"class_name : template_class_name",
"template_class_name : IDENTIFIER '<' template_args '>'",
"template_args :",
"const_expression :",
"decl_specifier : storage_class_specifier",
"decl_specifier : type_specifier",
"decl_specifier : fct_specifier",
"decl_specifier : FRIEND",
"decl_specifier : TYPEDEF",
"decl_specifiers : decl_specs_opt type_name decl_specs_opt",
"decl_specs_opt :",
"decl_specs_opt : decl_specs",
"decl_specs : decl_specifier",
"decl_specs : decl_specs decl_specifier",
"storage_class_specifier : AUTO",
"storage_class_specifier : REGISTER",
"storage_class_specifier : STATIC",
"storage_class_specifier : EXTERN",
"fct_specifier : INLINE",
"fct_specifier : VIRTUAL",
"type_specifier : CONST",
"type_specifier : VOLATILE",
"type_name : elaborated_type_specifier",
"type_name : complete_class_name",
"type_name : simple_type_names",
"simple_type_names : simple_type_names simple_type_name",
"simple_type_names : simple_type_name",
"simple_type_name : CHAR",
"simple_type_name : SHORT",
"simple_type_name : INT",
"simple_type_name : LONG",
"simple_type_name : SIGNED",
"simple_type_name : UNSIGNED",
"simple_type_name : FLOAT",
"simple_type_name : DOUBLE",
"simple_type_name : VOID",
"template_spec : TEMPLATE '<' template_args '>'",
"opt_template_spec :",
"opt_template_spec : template_spec",
"class_key : opt_template_spec CLASS",
"class_key : opt_template_spec STRUCT",
"complete_class_name : qualified_class_name",
"complete_class_name : DBL_COLON qualified_class_name",
"qualified_class_name : qualified_class_name DBL_COLON class_name",
"qualified_class_name : class_name",
"elaborated_type_specifier : class_key IDENTIFIER",
"elaborated_type_specifier : ENUM IDENTIFIER",
"elaborated_type_specifier : UNION IDENTIFIER",
"argument_declaration_list : arg_declaration_list_opt triple_dot_opt",
"argument_declaration_list : arg_declaration_list ',' TRIPLE_DOT",
"arg_declaration_list_opt :",
"arg_declaration_list_opt : arg_declaration_list",
"triple_dot_opt :",
"triple_dot_opt : TRIPLE_DOT",
"arg_declaration_list : arg_declaration_list ',' argument_declaration",
"arg_declaration_list : argument_declaration",
"argument_declaration : decl_specifiers abstract_decl_opt",
"$$2 :",
"argument_declaration : decl_specifiers abstract_decl_opt '=' $$2 const_expression",
"argument_declaration : decl_specifiers abstract_decl_opt dname abstract_decl_opt",
"$$3 :",
"argument_declaration : decl_specifiers abstract_decl_opt dname abstract_decl_opt '=' $$3 const_expression",
"abstract_decl_opt :",
"abstract_decl_opt : abstract_decl",
"abstract_decl : abstract_decl ptr_operator",
"$$4 :",
"abstract_decl : '[' $$4 const_expression ']'",
"$$5 :",
"abstract_decl : abstract_decl '[' $$5 const_expression ']'",
"abstract_decl : ptr_operator",
"abstract_decl : '(' abstract_decl ')'",
"declarator : dname",
"declarator : declarator ptr_operator",
"$$6 :",
"declarator : declarator '[' $$6 const_expression ']'",
"declarator : '(' declarator ')'",
"dname : IDENTIFIER",
"fct_decl : '(' argument_declaration_list ')' cv_qualifier_list_opt fct_body_or_semicolon",
"fct_name : IDENTIFIER",
"fct_name : IDENTIFIER array_decls",
"$$7 :",
"fct_name : IDENTIFIER '=' $$7 const_expression",
"$$8 :",
"fct_name : IDENTIFIER array_decls '=' $$8 const_expression",
"$$9 :",
"array_decls : '[' $$9 const_expression ']'",
"$$10 :",
"array_decls : array_decls '[' $$10 const_expression ']'",
"ptr_operators_opt :",
"ptr_operators_opt : ptr_operators",
"ptr_operators : ptr_operator",
"ptr_operators : ptr_operators ptr_operator",
"ptr_operator : '*' cv_qualifier_list_opt",
"ptr_operator : '&' cv_qualifier_list_opt",
"cv_qualifier_list_opt :",
"cv_qualifier_list_opt : cv_qualifier_list",
"cv_qualifier_list : cv_qualifier",
"cv_qualifier_list : cv_qualifier_list cv_qualifier",
"cv_qualifier : CONST",
"cv_qualifier : VOLATILE",
"fct_body_or_semicolon : ';'",
"fct_body_or_semicolon : fct_body",
"fct_body_or_semicolon : '=' INT_VAL ';'",
"$$11 :",
"fct_body : '{' $$11 '}'",
"$$12 :",
"class_specifier : class_head '{' $$12 opt_obj_member_list '}'",
"class_specifier : class_key class_name",
"class_specifier : class_key class_name '(' IDENTIFIER ')'",
"class_specifier : template_spec whatever",
"whatever : IDENTIFIER",
"whatever : simple_type_name",
"whatever : type_specifier",
"whatever : storage_class_specifier",
"whatever : fct_specifier",
"$$13 :",
"class_head : class_key class_name $$13 opt_base_spec",
"opt_base_spec :",
"opt_base_spec : base_spec",
"opt_obj_member_list :",
"opt_obj_member_list : obj_member_list",
"obj_member_list : obj_member_list obj_member_area",
"obj_member_list : obj_member_area",
"qt_access_specifier : access_specifier",
"qt_access_specifier : SLOTS",
"$$14 :",
"obj_member_area : qt_access_specifier $$14 slot_area",
"$$15 :",
"obj_member_area : SIGNALS $$15 ':' opt_signal_declarations",
"obj_member_area : Q_OBJECT",
"slot_area : SIGNALS ':'",
"slot_area : SLOTS ':' opt_slot_declarations",
"$$16 :",
"slot_area : ':' $$16 opt_slot_declarations",
"slot_area : IDENTIFIER",
"opt_signal_declarations :",
"opt_signal_declarations : signal_declarations",
"signal_declarations : signal_declarations signal_declaration",
"signal_declarations : signal_declaration",
"signal_declaration : signal_or_slot",
"opt_slot_declarations :",
"opt_slot_declarations : slot_declarations",
"slot_declarations : slot_declarations slot_declaration",
"slot_declarations : slot_declaration",
"slot_declaration : signal_or_slot",
"opt_semicolons :",
"opt_semicolons : opt_semicolons ';'",
"base_spec : ':' base_list",
"base_list : base_list ',' base_specifier",
"base_list : base_specifier",
"qt_macro_name : IDENTIFIER '(' IDENTIFIER ')'",
"qt_macro_name : IDENTIFIER '(' simple_type_name ')'",
"base_specifier : complete_class_name",
"base_specifier : VIRTUAL access_specifier complete_class_name",
"base_specifier : VIRTUAL complete_class_name",
"base_specifier : access_specifier VIRTUAL complete_class_name",
"base_specifier : access_specifier complete_class_name",
"base_specifier : qt_macro_name",
"base_specifier : VIRTUAL access_specifier qt_macro_name",
"base_specifier : VIRTUAL qt_macro_name",
"base_specifier : access_specifier VIRTUAL qt_macro_name",
"base_specifier : access_specifier qt_macro_name",
"access_specifier : PRIVATE",
"access_specifier : PROTECTED",
"access_specifier : PUBLIC",
"operator_name : decl_specs_opt IDENTIFIER ptr_operators_opt",
"operator_name : decl_specs_opt simple_type_name ptr_operators_opt",
"operator_name : '+'",
"operator_name : '-'",
"operator_name : '*'",
"operator_name : '/'",
"operator_name : '%'",
"operator_name : '^'",
"operator_name : '&'",
"operator_name : '|'",
"operator_name : '~'",
"operator_name : '!'",
"operator_name : '='",
"operator_name : '<'",
"operator_name : '>'",
"operator_name : '+' '='",
"operator_name : '-' '='",
"operator_name : '*' '='",
"operator_name : '/' '='",
"operator_name : '%' '='",
"operator_name : '^' '='",
"operator_name : '&' '='",
"operator_name : '|' '='",
"operator_name : '~' '='",
"operator_name : '!' '='",
"operator_name : '=' '='",
"operator_name : '<' '='",
"operator_name : '>' '='",
"operator_name : '<' '<'",
"operator_name : '>' '>'",
"operator_name : '<' '<' '='",
"operator_name : '>' '>' '='",
"operator_name : '&' '&'",
"operator_name : '|' '|'",
"operator_name : '+' '+'",
"operator_name : '-' '-'",
"operator_name : ','",
"operator_name : '-' '>' '*'",
"operator_name : '-' '>'",
"operator_name : '(' ')'",
"operator_name : '[' ']'",
"opt_virtual :",
"opt_virtual : VIRTUAL",
"type_and_name : type_name fct_name",
"type_and_name : fct_name",
"type_and_name : opt_virtual '~' fct_name",
"type_and_name : decl_specs type_name decl_specs_opt ptr_operators_opt fct_name",
"type_and_name : decl_specs type_name",
"type_and_name : type_name ptr_operators fct_name",
"type_and_name : type_name decl_specs ptr_operators_opt fct_name",
"type_and_name : type_name OPERATOR operator_name",
"type_and_name : OPERATOR operator_name",
"type_and_name : decl_specs type_name decl_specs_opt ptr_operators_opt OPERATOR operator_name",
"type_and_name : type_name ptr_operators OPERATOR operator_name",
"type_and_name : type_name decl_specs ptr_operators_opt OPERATOR operator_name",
"signal_or_slot : type_and_name fct_decl opt_semicolons",
"signal_or_slot : type_and_name opt_bitfield ';' opt_semicolons",
"signal_or_slot : type_and_name opt_bitfield ',' member_declarator_list ';' opt_semicolons",
"signal_or_slot : enum_specifier ';' opt_semicolons",
"member_declarator_list : member_declarator",
"member_declarator_list : member_declarator_list ',' member_declarator",
"member_declarator : declarator",
"$$17 :",
"member_declarator : IDENTIFIER ':' $$17 const_expression",
"$$18 :",
"member_declarator : ':' $$18 const_expression",
"opt_bitfield :",
"$$19 :",
"opt_bitfield : ':' $$19 const_expression",
"$$20 :",
"enum_specifier : ENUM opt_identifier '{' $$20 '}'",
"opt_identifier :",
"opt_identifier : IDENTIFIER",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 760 "moc.y"

#if defined(_OS_WIN32_)
#if defined(_CC_MSVC_)
extern "C" int _isatty( int );
#define isatty _isatty
#elif defined(_CC_SYM_)
#include <io.h>
#endif
#endif

#include "lex.yy.c"

void 	  init();				// initialize
void 	  initClass();				// prepare for new class
void 	  generateClass();			// generate C++ code for class
void 	  initExpression();			// prepare for new expression
QString	  combinePath( const char *, const char * );

QString	  fileName;				// file name
QString	  outputFile;				// output file name
QString   includeFile;				// name of #include file
QString	  includePath;				// #include file path
QString	  qtPath;				// #include qt file path
bool	  noInclude     = FALSE;		// no #include <filename>
bool	  generatedCode = FALSE;		// no code generated
QString	  className;				// name of parsed class
QString	  superclassName;			// name of super class
FuncList  signals;				// signal interface
FuncList  slots;				// slots interface
QDict<char> defines;				// simple #defines

FILE  *out;					// output file

int yyparse();

void replace( char *s, char c1, char c2 );

int main( int argc, char **argv )
{
    bool autoInclude = TRUE;
    char *error	     = 0;
    qtPath = "";

    for ( int n=1; n<argc && error==0; n++ ) {
	QString arg = argv[n];
	if ( arg[0] == '-' ) {			// option
	    QString opt = &arg[1];
	    if ( opt[0] == 'o' ) {		// output redirection
		if ( opt[1] == '\0' ) {
		    if ( !(n < argc-1) ) {
			error = "Missing output-file name";
			break;
		    }
		    outputFile = argv[++n];
		} else
		    outputFile = &opt[1];
	    } else if ( opt == "i" ) {		// no #include statement
		noInclude   = TRUE;
		autoInclude = FALSE;
	    } else if ( opt[0] == 'D' ) {	// simple -DMACRO
		int eq = opt.find('=');
		if ( strlen(opt) > 1 && eq != 0 ) {
		    defines.insert( opt.mid(1, eq < 0 ? 9999 : eq-1),
				    qstrdup(eq < 0 ? "" :
					    (const char*)opt.mid(eq,9999)) );
		}
	    } else if ( opt[0] == 'f' ) {	// produce #include statement
		noInclude   = FALSE;
		autoInclude = FALSE;
		if ( opt[1] ) {			// -fsomething.h
		    includeFile = &opt[1];
		}
	    } else if ( opt[0] == 'p' ) {	// include file path
		if ( opt[1] == '\0' ) {
		    if ( !(n < argc-1) ) {
			error = "Missing path name for the -p option.";
			break;
		    }
		    includePath = argv[++n];
		} else {
		    includePath = &opt[1];
		}
	    } else if ( opt[0] == 'q' ) {	// qt include file path
		if ( opt[1] == '\0' ) {
		    if ( !(n < argc-1) ) {
			error = "Missing path name for the -q option.";
			break;
		    }
		    qtPath = argv[++n];
		} else {
		    qtPath = &opt[1];
		}
		replace(qtPath.data(),'\\','/');
		if ( qtPath.right(1) != "/" )
		    qtPath += '/';
	    } else if ( opt == "k" ) {		// don't stop on errors
		errorControl = TRUE;
	    } else if ( opt == "nw" ) {		// don't display warnings
		displayWarnings = FALSE;
	    } else if ( opt == "ldbg" ) {	// lex debug output
		lexDebug = TRUE;
	    } else if ( opt == "ydbg" ) {	// yacc debug output
		yydebug = TRUE;
	    } else if ( opt == "dbg" ) {	// non-signal members are slots
		grammarDebug = TRUE;
	    } else {
		error = "Invalid argument";
	    }
	} else {
	    if ( !fileName.isNull() )		// can handle only one file
		error	 = "Too many input files specified";
	    else
		fileName = arg.copy();
	}
    }

    if ( autoInclude ) {
	int ppos = fileName.findRev('.');
	if ( ppos != -1 && tolower( fileName[ppos + 1] ) == 'h' )
	    noInclude = FALSE;
	else
	    noInclude = TRUE;
    }
    if ( !fileName.isEmpty() && !outputFile.isEmpty() &&
	 includeFile.isEmpty() && includePath.isEmpty() ) {
	includeFile = combinePath(fileName,outputFile);
    }
    if ( includeFile.isEmpty() )
	includeFile = fileName.copy();
    if ( !includePath.isEmpty() ) {
	if ( includePath.right(1) != "/" )
	    includePath += '/';
	includeFile = includePath + includeFile;
    }
    if ( fileName.isNull() && !error ) {
	fileName = "standard input";
	yyin	 = stdin;
    } else if ( argc < 2 || error ) {		// incomplete/wrong args
	fprintf( stderr, "Qt meta object compiler\n" );
	if ( error )
	    fprintf( stderr, "moc: %s\n", error );
	fprintf( stderr, "Usage:  moc [options] <header-file>\n"
		 "\t-D[macro] Define a macro (for #ifdef processing)\n"
		 "\t-o file   Write output to file rather than stdout\n"
		 "\t-i        Do not generate an #include statement\n"
		 "\t-f[file]  Force #include, optional file name\n"
		 "\t-p path   Path prefix for included file\n"
		 "\t-k        Do not stop on errors\n"
		 "\t-nw       Do not display warnings\n"
#if 0
		 "\t-ldbg     lex debug output\n"
		 "\t-ydbg     yacc debug output\n"
		 "\t-dbg      test parser, all non-signal members are slots\n"
#endif
		 );
	return 1;
    } else {
	yyin = fopen( (const char *)fileName, "r" );
	if ( !yyin ) {
	    fprintf( stderr, "moc: %s: No such file\n", (const char*)fileName);
	    return 1;
	}
    }
    if ( !outputFile.isEmpty() ) {		// output file specified
	out = fopen( (const char *)outputFile, "w" );	// create output file
	if ( !out ) {
	    fprintf( stderr, "moc: Cannot create %s\n",
		     (const char*)outputFile );
	    return 1;
	}
    } else {					// use stdout
	out = stdout;
    }
    init();
    yyparse();
    fclose( yyin );
    if ( !outputFile.isNull() )
	fclose( out );

    if ( !generatedCode && displayWarnings ) {
        fprintf( stderr, "%s:%d: Warning: %s\n", fileName.data(), 0, 
		 "No relevant classes found. No output generated." );
    }

    slots.clear();
    signals.clear();
    return 0;
}

void replace( char *s, char c1, char c2 )
{
    if ( !s )
	return;
    while ( *s ) {
	if ( *s == c1 )
	    *s = c2;
	s++;
    }
}

/*
  This function looks at two file names and returns the name of the
  infile, with a path relative to outfile. Examples:
    /tmp/abc	/tmp/bcd	->	abc
    xyz/a/bc	xyz/b/ac	->	../a/bc
    /tmp/abc	xyz/klm		-)	/tmp/abc
 */

QString combinePath( const char *infile, const char *outfile )
{
    QString a = infile;  replace(a.data(),'\\','/');
    QString b = outfile; replace(b.data(),'\\','/');
    a = a.stripWhiteSpace();
    b = b.stripWhiteSpace();
#if !defined(UNIX)
    a = a.lower();
    b = b.lower();
#endif
    QString r;
    int i = 0;
    int ncommondirs = 0;
    while ( a[i] && a[i] == b[i] ) {
	if ( a[i] == '/' && i > 0 )
	    ncommondirs++;
	i++;
    }
    if ( ncommondirs > 0 ) {			// common base directory
	while ( i>=0 ) {
	    if ( a[i] == '/' && b[i] == '/' )
		break;
	    --i;
	}
	++i;
	a = &a[i];
	b = &b[i];
    } else {
#if defined(UNIX)
	if ( a[0] == '/' )
#else
	if ( (a[0] == '/') || (isalpha(a[0]) && a[1] == ':') )
#endif
	    return a;
	b = &b[i];
    }
    i = b.contains('/');
    while ( i-- > 0 )
	r += "../";
    r += a;
    return r;
}


#define getenv hack_getenv			// workaround for byacc
char *getenv()		     { return 0; }
char *getenv( const char * ) { return 0; }


void init()					// initialize
{
    BEGIN OUTSIDE;
    lineNo	 = 1;
    skipClass	 = FALSE;
    skipFunc	 = FALSE;
    signals.setAutoDelete( TRUE );
    slots.setAutoDelete( TRUE );

    tmpArgList	 = new ArgList;
    CHECK_PTR( tmpArgList );
    tmpFunc	 = new Function;
    CHECK_PTR( tmpFunc );
}

void initClass()				 // prepare for new class
{
    tmpAccessPerm    = _PRIVATE;
    subClassPerm     = _PRIVATE;
    Q_OBJECTdetected = FALSE;
    skipClass	     = FALSE;
    templateClass    = FALSE;
    slots.clear();
    signals.clear();
}

//
// Remove white space from SIGNAL and SLOT names.
// This function has been copied from qobject.cpp.
//

inline bool isIdentChar( char x )
{						// Avoid bug in isalnum
    return x == '_' || (x >= '0' && x <= '9') ||
	 (x >= 'a' && x <= 'z') || (x >= 'A' && x <= 'Z');
}

inline bool isSpace( char x )
{
#if defined(_CC_BOR_)
  /*
    Borland C++ 4.5 has a weird isspace() bug.
    isspace() usually works, but not here.
    This implementation is sufficient for our internal use: rmWS()
  */
    return (uchar)x <= 32;
#else
    return isspace( x );
#endif
}

static QString rmWS( const char *src )
{
    QString result( strlen(src)+1 );
    char *d = result.data();
    char *s = (char *)src;
    char last = 0;
    while( *s && isSpace(*s) )			// skip leading space
	s++;
    while ( *s ) {
	while ( *s && !isSpace(*s) )
	    last = *d++ = *s++;
	while ( *s && isSpace(*s) )
	    s++;
	if ( *s && isIdentChar(*s) && isIdentChar(last) )
	    last = *d++ = ' ';
    }
    result.truncate( (int)(d - result.data()) );
    return result;
}


void initExpression()
{
    tmpExpression = "";
}

void addExpressionString( char *s )
{
    tmpExpression += s;
}

void addExpressionChar( char c )
{
    tmpExpression += c;
}

void yyerror( char *msg )			// print yacc error message
{

    fprintf( stderr, "%s:%d: Error: %s\n", fileName.data(), lineNo, msg);
}

void moc_err( char *s )
{
    yyerror( s );
    if ( errorControl )
	exit( -1 );
}

void moc_err( char *s1, char *s2 )
{
    static char tmp[1024];
    sprintf( tmp, s1, s2 );
    yyerror( tmp );
    if ( errorControl )
	exit( -1 );
}

void moc_warn( char *msg )
{
    if ( displayWarnings )
	fprintf( stderr, "%s:%d: Warning: %s\n", fileName.data(), lineNo, msg);
}

void func_warn( char *msg )
{
    moc_warn( msg );
    skipFunc = TRUE;
}

void operatorError()
{
    moc_warn("Operator functions cannot be signals or slots.");
    skipFunc = TRUE;
}

#ifndef yywrap
int yywrap()					// more files?
{
    return 1;					// end of file
}
#endif

char *stradd( const char *s1, const char *s2 )	// adds two strings
{
    char *n = new char[strlen(s1)+strlen(s2)+1];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, s2 );
    return n;
}

char *stradd( const char *s1, const char *s2, const char *s3 )// adds 3 strings
{
    char *n = new char[strlen(s1)+strlen(s2)+strlen(s3)+1];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, s2 );
    strcat( n, s3 );
    return n;
}

char *stradd( const char *s1, const char *s2,
	      const char *s3, const char *s4 )// adds 4 strings
{
    char *n = new char[strlen(s1)+strlen(s2)+strlen(s3)+strlen(s4)+1];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, s2 );
    strcat( n, s3 );
    strcat( n, s4 );
    return n;
}


char *straddSpc( const char *s1, const char *s2 )
{
    char *n = new char[strlen(s1)+strlen(s2)+2];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, " " );
    strcat( n, s2 );
    return n;
}

char *straddSpc( const char *s1, const char *s2, const char *s3 )
{
    char *n = new char[strlen(s1)+strlen(s2)+strlen(s3)+3];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, " " );
    strcat( n, s2 );
    strcat( n, " " );
    strcat( n, s3 );
    return n;
}

char *straddSpc( const char *s1, const char *s2,
	      const char *s3, const char *s4 )
{
    char *n = new char[strlen(s1)+strlen(s2)+strlen(s3)+strlen(s4)+4];
    CHECK_PTR( n );
    strcpy( n, s1 );
    strcat( n, " " );
    strcat( n, s2 );
    strcat( n, " " );
    strcat( n, s3 );
    strcat( n, " " );
    strcat( n, s4 );
    return n;
}

// Generate C++ code for building member function table

const int Slot_Num   = 1;
const int Signal_Num = 2;

void generateFuncs( FuncList *list, char *functype, int num )
{
    Function *f;
    for ( f=list->first(); f; f=list->next() ) {
	QString typstr = "";
	int count = 0;
	Argument *a = f->args->first();
	while ( a ) {
	    if ( !a->leftType.isEmpty() || ! a->rightType.isEmpty() ) {
		if ( count++ )
		    typstr += ",";
		typstr += a->leftType;
		typstr += a->rightType;
	    }
	    a = f->args->next();
	}
	fprintf( out, "    typedef %s(%s::*m%d_t%d)(%s)%s;\n",
		 (const char*)f->type, (const char*)className, num, list->at(),
		 (const char*)typstr,  (const char*)f->qualifier );
	f->type = f->name.copy();
	f->type += "(";
	f->type += typstr;
	f->type += ")";
    }
    for ( f=list->first(); f; f=list->next() )
	fprintf( out, "    m%d_t%d v%d_%d = &%s::%s;\n", num, list->at(),
		 num, list->at(), (const char*)className,(const char*)f->name);
    if ( list->count() )
	fprintf( out, "    QMetaData *%s_tbl = new QMetaData[%d];\n",
		 functype, list->count() );
    for ( f=list->first(); f; f=list->next() )
	fprintf( out, "    %s_tbl[%d].name = \"%s\";\n",
		 functype, list->at(), (const char*)f->type );
    for ( f=list->first(); f; f=list->next() )
	fprintf( out, "    %s_tbl[%d].ptr = *((QMember*)&v%d_%d);\n",
		 functype, list->at(), num, list->at() );
}

void generateClass()		      // generate C++ source code for a class
{
    static int gen_count = 0;
    char *hdr1 = "/****************************************************************************\n"
		 "** %s meta object code from reading C++ file '%s'\n**\n";
    char *hdr2 = "** Created: %s\n"
		 "**      by: The Qt Meta Object Compiler ($Revision: 2.25 $)\n**\n";
    char *hdr3 = "** WARNING! All changes made in this file will be lost!\n";
    char *hdr4 = "*****************************************************************************/\n\n";
    int   i;

    if ( skipClass )				// don't generate for class
	return;
    if ( !Q_OBJECTdetected ) {
	if ( signals.count() == 0 && slots.count() == 0 )
	    return;
	generatedCode = TRUE;
	if ( displayWarnings )
	    moc_err("The declaration of the class \"%s\" contains slots "
		    "and/or signals\n\t but no Q_OBJECT macro!", className.data());
    } else {
	if ( superclassName.isEmpty() )
	    moc_err("The declaration of the class \"%s\" contains the\n"
		    "\tQ_OBJECT macro but does not inherit from any class!\n"
		    "\tInherit from QObject or one of its descendants"
		    " or remove Q_OBJECT. ", className.data() );
    }
    if ( templateClass ) {			// don't generate for class
	moc_err( "Sorry, Qt does not support templates that contain\n"
		 "signals, slots or Q_OBJECT. This will be supported soon." );
	return;
    }
    generatedCode = TRUE;
    if ( gen_count++ == 0 ) {			// first class to be generated
	QDateTime dt = QDateTime::currentDateTime();
	QString dstr = dt.toString();
	QString fn = fileName;
	i = fileName.length()-1;
	while ( i>0 && fileName[i-1] != '/' && fileName[i-1] != '\\' )
	    i--;				// skip path
	if ( i >= 0 )
	    fn = &fileName[i];
	fprintf( out, hdr1, (const char*)className, (const char*)fn );
	fprintf( out, hdr2, (const char*)dstr );
	fprintf( out, hdr3 );
	fprintf( out, hdr4 );
	fprintf( out, "#if !defined(Q_MOC_OUTPUT_REVISION)\n" );
	fprintf( out, "#define Q_MOC_OUTPUT_REVISION %d\n", formatRevision );
	fprintf( out, "#elif Q_MOC_OUTPUT_REVISION != %d\n", formatRevision );
	fprintf( out, "#error \"Moc format conflict - "
		 "please regenerate all moc files\"\n" );
	fprintf( out, "#endif\n\n" );
	if ( !noInclude )
	    fprintf( out, "#include \"%s\"\n", (const char*)includeFile );
	fprintf( out, "#include <%sqmetaobject.h>\n", (const char*)qtPath );
	fprintf( out, "\n\n" );
    } else {
	fprintf( out, "\n\n" );
    }

//
// Generate virtual function className()
//
    fprintf( out, "const char *%s::className() const\n{\n    ",
	     (const char*)className );
    fprintf( out, "return \"%s\";\n}\n\n", (const char*)className );

//
// Generate static metaObj variable
//
    fprintf( out, "QMetaObject *%s::metaObj = 0;\n\n", (const char*)className);

//
// Generate initMetaObject member function
//
    fprintf( out, "void %s::initMetaObject()\n{\n", (const char*)className );
    fprintf( out, "    if ( metaObj )\n\treturn;\n" );
    fprintf( out, "    if ( strcmp(%s::className(), \"%s\") != 0 )\n"
	          "\tbadSuperclassWarning(\"%s\",\"%s\");\n",
             (const char*)superclassName, (const char*)superclassName,
             (const char*)className, (const char*)superclassName );
    fprintf( out, "    if ( !%s::metaObject() )\n\t%s::initMetaObject();\n",
	     (const char*)superclassName, (const char*)superclassName );
//
// Build slots array in initMetaObject()
//
    generateFuncs( &slots, "slot", Slot_Num );

//
// Build signals array in initMetaObject()
//
    generateFuncs( &signals, "signal", Signal_Num );

//
// Finally code to create meta object
//
    fprintf( out, "    metaObj = new QMetaObject( \"%s\", \"%s\",\n",
	     (const char*)className, (const char*)superclassName );
    if ( slots.count() )
	fprintf( out, "\tslot_tbl, %d,\n", slots.count() );
    else
	fprintf( out, "\t0, 0,\n" );
    if ( signals.count() )
	fprintf( out, "\tsignal_tbl, %d );\n", signals.count());
    else
	fprintf( out, "\t0, 0 );\n" );
    fprintf( out, "}\n" );

//
// End of function initMetaObject()
//

//
// Generate internal signal functions
//
    Function *f;
    f = signals.first();			// make internal signal methods
    static bool included_list_stuff = FALSE;
    while ( f ) {
	QString typstr = "";			// type string
	QString valstr = "";			// value string
	QString argstr = "";			// argument string (type+value)
	char	buf[12];
	Argument *a = f->args->first();
	QString typvec[32], valvec[32], argvec[32];
	typvec[0] = "";
	valvec[0] = "";
	argvec[0] = "";

	i = 0;
	while ( a ) {				// argument list
	    if ( !a->leftType.isEmpty() || !a->rightType.isEmpty() ) {
		if ( i ) {
		    typstr += ",";
		    valstr += ", ";
		    argstr += ", ";
		}
		typstr += a->leftType;
		typstr += a->rightType;
		argstr += a->leftType;
		argstr += " ";
		sprintf( buf, "t%d", i );
		valstr += buf;
		argstr += buf;
		argstr += a->rightType;
		++i;
		typvec[i] = typstr.copy();
		valvec[i] = valstr.copy();
		argvec[i] = argstr.copy();
	    }
	    a = f->args->next();
	}

	bool predef_call = FALSE;
	if ( typstr.isEmpty() || typstr == "short" || typstr == "int" ||
	     typstr == "long" || typstr == "char*" || typstr == "const char*"){
	    predef_call = TRUE;
	}
	if ( !predef_call && !included_list_stuff ) {
	    fprintf( out, "\n#if !defined(Q_MOC_CONNECTIONLIST_DECLARED)\n" );
	    fprintf( out, "#define Q_MOC_CONNECTIONLIST_DECLARED\n" );
	    fprintf( out, "#include <%sqlist.h>\n", (const char*)qtPath );
	    fprintf( out, "#if defined(Q_DECLARE)\n" );
	    fprintf( out, "Q_DECLARE(QListM,QConnection);\n" );
	    fprintf( out, "Q_DECLARE(QListIteratorM,QConnection);\n" );
	    fprintf( out, "#else\n" );
	    fprintf( out, "/" "/ for compatibility with old header files\n" );
	    fprintf( out, "declare(QListM,QConnection);\n" );
	    fprintf( out, "declare(QListIteratorM,QConnection);\n" );
	    fprintf( out, "#endif\n" );
	    fprintf( out, "#endif\n" );
	    included_list_stuff = TRUE;
	}

	fprintf( out, "\n/" /* c++ */ "/ SIGNAL %s\n", (const char*)f->name );
	fprintf( out, "void %s::%s(", (const char*)className,
		 (const char*)f->name );

	if ( argstr.isEmpty() )
	    fprintf( out, ")\n{\n" );
	else
	    fprintf( out, " %s )\n{\n", (const char*)argstr );

	if ( predef_call ) {
	    fprintf( out, "    activate_signal( \"%s(%s)\"",
		     (const char*)f->name, (const char*)typstr );
	    if ( !valstr.isEmpty() )
		fprintf( out, ", %s", (const char*)valstr );
	    fprintf( out, " );\n}\n" );
	    f = signals.next();
	    continue;
	}

	int nargs = f->args->count();
	fprintf( out, "    QConnectionList *clist = receivers(\"%s(%s)\");\n",
		 (const char*)f->name, (const char*)typstr );
	fprintf( out, "    if ( !clist || signalsBlocked() )\n\treturn;\n" );
	if ( nargs ) {
	    for ( i=0; i<=nargs; i++ ) {
		fprintf( out, "    typedef void (QObject::*RT%d)(%s);\n",
			 i, (const char*)typvec[i] );
		fprintf( out, "    typedef RT%d *PRT%d;\n", i, i );
	    }
	} else {
	    fprintf( out, "    typedef void (QObject::*RT)(%s);\n",
		     (const char*)typstr);
	    fprintf( out, "    typedef RT *PRT;\n" );	    
	}
	if ( nargs ) {
	    for ( i=0; i<=nargs; i++ )
		fprintf( out, "    RT%d r%d;\n", i, i );
	} else {
	    fprintf( out, "    RT r;\n" );
	}
	fprintf( out, "    QConnectionListIt it(*clist);\n" );
	fprintf( out, "    QConnection   *c;\n" );
	fprintf( out, "    QSenderObject *object;\n" );
	fprintf( out, "    while ( (c=it.current()) ) {\n" );
	fprintf( out, "\t++it;\n" );
	fprintf( out, "\tobject = (QSenderObject*)c->object();\n" );
	fprintf( out, "\tobject->setSender( this );\n" );
	if ( nargs ) {
	    fprintf( out, "\tswitch ( c->numArgs() ) {\n" );
	    for ( i=0; i<=nargs; i++ ) {
		fprintf( out, "\t    case %d:\n", i );
		fprintf( out, "\t\tr%d = *((PRT%d)(c->member()));\n", i, i );
		fprintf( out, "\t\t(object->*r%d)(%s);\n",
			 i, (const char*)valvec[i] );
		fprintf( out, "\t\tbreak;\n" );
	    }
	    fprintf( out, "\t}\n" );
	} else {
	    fprintf( out, "\tr = *((PRT)(c->member()));\n" );
	    fprintf( out, "\t(object->*r)(%s);\n", (const char*)valstr );
	}
	fprintf( out, "    }\n}\n" );
	f = signals.next();
    }

}


ArgList *addArg( Argument *a )			// add argument to list
{
    tmpArgList->append( a );
    return tmpArgList;
}

void addMember( char m )
{
    if ( skipFunc ) {
	tmpArgList  = new ArgList;   // ugly but works!
	CHECK_PTR( tmpArgList );
	tmpFunc	    = new Function;
	CHECK_PTR( tmpFunc );
	skipFunc    = FALSE;
	return;
    }
    if ( m == 's' && tmpFunc->type != "void" ) {
	moc_err( "Signals must have \"void\" as their return type" );
	return;
    }
    tmpFunc->accessPerm = tmpAccessPerm;
    tmpFunc->args	= tmpArgList;
    tmpFunc->lineNo	= lineNo;
    tmpArgList		= new ArgList;
    CHECK_PTR( tmpArgList );
    switch( m ) {
	case 's': signals.append( tmpFunc ); break;
	case 't': slots.  append( tmpFunc ); break;
    }
    skipFunc = FALSE;
    tmpFunc  = new Function;
    CHECK_PTR( tmpFunc );
}
#line 1634 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 221 "moc.y"
{ initClass(); }
break;
case 4:
#line 222 "moc.y"
{ generateClass();
						BEGIN OUTSIDE; }
break;
case 5:
#line 229 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 6:
#line 230 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 7:
#line 234 "moc.y"
{ yyval.string = stradd( yyvsp[-3].string, "<",
				     tmpExpression =
				     tmpExpression.stripWhiteSpace(), ">" ); }
break;
case 8:
#line 245 "moc.y"
{ initExpression();
						    templLevel = 1;
						    BEGIN IN_TEMPL_ARGS; }
break;
case 9:
#line 258 "moc.y"
{ initExpression();
						    BEGIN IN_EXPR; }
break;
case 10:
#line 264 "moc.y"
{ yyval.string = ""; }
break;
case 11:
#line 265 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 12:
#line 266 "moc.y"
{ yyval.string = ""; }
break;
case 13:
#line 267 "moc.y"
{ skipFunc = TRUE; yyval.string = ""; }
break;
case 14:
#line 268 "moc.y"
{ skipFunc = TRUE; yyval.string = ""; }
break;
case 15:
#line 272 "moc.y"
{ yyval.string = straddSpc(yyvsp[-2].string,yyvsp[-1].string,yyvsp[0].string); }
break;
case 16:
#line 275 "moc.y"
{ yyval.string = ""; }
break;
case 17:
#line 276 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 18:
#line 279 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 19:
#line 280 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string); }
break;
case 22:
#line 285 "moc.y"
{ skipFunc = TRUE; }
break;
case 26:
#line 293 "moc.y"
{ yyval.string = "const"; }
break;
case 27:
#line 294 "moc.y"
{ yyval.string = "volatile"; }
break;
case 28:
#line 297 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 29:
#line 298 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 30:
#line 299 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 31:
#line 303 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string); }
break;
case 32:
#line 304 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 33:
#line 306 "moc.y"
{ yyval.string = "char"; }
break;
case 34:
#line 307 "moc.y"
{ yyval.string = "short"; }
break;
case 35:
#line 308 "moc.y"
{ yyval.string = "int"; }
break;
case 36:
#line 309 "moc.y"
{ yyval.string = "long"; }
break;
case 37:
#line 310 "moc.y"
{ yyval.string = "signed"; }
break;
case 38:
#line 311 "moc.y"
{ yyval.string = "unsigned"; }
break;
case 39:
#line 312 "moc.y"
{ yyval.string = "float"; }
break;
case 40:
#line 313 "moc.y"
{ yyval.string = "double"; }
break;
case 41:
#line 314 "moc.y"
{ yyval.string = "void"; }
break;
case 42:
#line 318 "moc.y"
{ yyval.string = stradd( "template<",
				     tmpExpression =
				     tmpExpression.stripWhiteSpace(), ">" ); }
break;
case 44:
#line 324 "moc.y"
{ templateClass = TRUE; }
break;
case 45:
#line 328 "moc.y"
{ yyval.string = "class"; }
break;
case 46:
#line 329 "moc.y"
{ yyval.string = "struct"; }
break;
case 47:
#line 332 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 48:
#line 334 "moc.y"
{ yyval.string = stradd( "::", yyvsp[0].string ); }
break;
case 49:
#line 338 "moc.y"
{ yyval.string = stradd( yyvsp[-2].string, "::", yyvsp[0].string );}
break;
case 50:
#line 339 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 51:
#line 343 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string); }
break;
case 52:
#line 344 "moc.y"
{ yyval.string = stradd("enum ",yyvsp[0].string); }
break;
case 53:
#line 345 "moc.y"
{ yyval.string = stradd("union ",yyvsp[0].string); }
break;
case 54:
#line 350 "moc.y"
{ yyval.arg_list = yyvsp[-1].arg_list;}
break;
case 55:
#line 351 "moc.y"
{ yyval.arg_list = yyvsp[-2].arg_list;
				       moc_warn("Ellipsis not supported"
					       " in signals and slots.\n"
					       "Ellipsis argument ignored."); }
break;
case 56:
#line 357 "moc.y"
{ yyval.arg_list = tmpArgList; }
break;
case 57:
#line 358 "moc.y"
{ yyval.arg_list = yyvsp[0].arg_list; }
break;
case 59:
#line 362 "moc.y"
{ moc_warn("Ellipsis not supported"
					       " in signals and slots.\n"
					       "Ellipsis argument ignored."); }
break;
case 60:
#line 370 "moc.y"
{ yyval.arg_list = addArg(yyvsp[0].arg); }
break;
case 61:
#line 371 "moc.y"
{ yyval.arg_list = addArg(yyvsp[0].arg); }
break;
case 62:
#line 374 "moc.y"
{ yyval.arg = new Argument(straddSpc(yyvsp[-1].string,yyvsp[0].string),"");
				  CHECK_PTR(yyval.arg); }
break;
case 63:
#line 377 "moc.y"
{ expLevel = 1; }
break;
case 64:
#line 379 "moc.y"
{ yyval.arg = new Argument(straddSpc(yyvsp[-4].string,yyvsp[-3].string),"");
				  CHECK_PTR(yyval.arg); }
break;
case 65:
#line 383 "moc.y"
{ yyval.arg = new Argument(straddSpc(yyvsp[-3].string,yyvsp[-2].string),yyvsp[0].string);
				  CHECK_PTR(yyval.arg); }
break;
case 66:
#line 387 "moc.y"
{ expLevel = 1; }
break;
case 67:
#line 389 "moc.y"
{ yyval.arg = new Argument(straddSpc(yyvsp[-6].string,yyvsp[-5].string),yyvsp[-3].string);
				  CHECK_PTR(yyval.arg); }
break;
case 68:
#line 394 "moc.y"
{ yyval.string = ""; }
break;
case 69:
#line 395 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 70:
#line 399 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string); }
break;
case 71:
#line 400 "moc.y"
{ expLevel = 1; }
break;
case 72:
#line 402 "moc.y"
{ yyval.string = stradd( "[",
				     tmpExpression =
				     tmpExpression.stripWhiteSpace(), "]" ); }
break;
case 73:
#line 405 "moc.y"
{ expLevel = 1; }
break;
case 74:
#line 407 "moc.y"
{ yyval.string = stradd( yyvsp[-4].string,"[",
				     tmpExpression =
				     tmpExpression.stripWhiteSpace(),"]" ); }
break;
case 75:
#line 410 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 76:
#line 411 "moc.y"
{ yyval.string = yyvsp[-1].string; }
break;
case 77:
#line 414 "moc.y"
{ yyval.string = ""; }
break;
case 78:
#line 416 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string);}
break;
case 79:
#line 417 "moc.y"
{ expLevel = 1; }
break;
case 80:
#line 419 "moc.y"
{ yyval.string = stradd( yyvsp[-4].string,"[",
				     tmpExpression =
				     tmpExpression.stripWhiteSpace(),"]" ); }
break;
case 81:
#line 422 "moc.y"
{ yyval.string = yyvsp[-1].string; }
break;
case 83:
#line 433 "moc.y"
{ tmpFunc->args	     = yyvsp[-3].arg_list;
						  tmpFunc->qualifier = yyvsp[-1].string; }
break;
case 85:
#line 439 "moc.y"
{ func_warn("Variable as signal or slot."); }
break;
case 86:
#line 440 "moc.y"
{ expLevel=0; }
break;
case 87:
#line 442 "moc.y"
{ skipFunc = TRUE; }
break;
case 88:
#line 443 "moc.y"
{ expLevel=0; }
break;
case 89:
#line 445 "moc.y"
{ skipFunc = TRUE; }
break;
case 90:
#line 449 "moc.y"
{ expLevel = 1; }
break;
case 92:
#line 451 "moc.y"
{ expLevel = 1; }
break;
case 94:
#line 456 "moc.y"
{ yyval.string = ""; }
break;
case 95:
#line 457 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 96:
#line 460 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 97:
#line 461 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string);}
break;
case 98:
#line 464 "moc.y"
{ yyval.string = straddSpc("*",yyvsp[0].string);}
break;
case 99:
#line 465 "moc.y"
{ yyval.string = stradd("&",yyvsp[0].string);}
break;
case 100:
#line 472 "moc.y"
{ yyval.string = ""; }
break;
case 101:
#line 473 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 102:
#line 476 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 103:
#line 478 "moc.y"
{ yyval.string = straddSpc(yyvsp[-1].string,yyvsp[0].string); }
break;
case 104:
#line 481 "moc.y"
{ yyval.string = "const"; }
break;
case 105:
#line 482 "moc.y"
{ yyval.string = "volatile"; }
break;
case 109:
#line 490 "moc.y"
{BEGIN IN_FCT; fctLevel = 1;}
break;
case 110:
#line 491 "moc.y"
{BEGIN QT_DEF; }
break;
case 111:
#line 498 "moc.y"
{ BEGIN IN_CLASS; level = 1; }
break;
case 112:
#line 500 "moc.y"
{ BEGIN QT_DEF; }
break;
case 113:
#line 501 "moc.y"
{ BEGIN QT_DEF;	  /* -- " -- */
						  skipClass = TRUE; }
break;
case 114:
#line 505 "moc.y"
{ BEGIN QT_DEF; /* catch ';' */
						  skipClass = TRUE; }
break;
case 115:
#line 507 "moc.y"
{ skipClass = TRUE;
						  BEGIN GIMME_SEMICOLON; }
break;
case 121:
#line 519 "moc.y"
{ className = yyvsp[0].string; }
break;
case 122:
#line 520 "moc.y"
{ superclassName = yyvsp[0].string; }
break;
case 123:
#line 523 "moc.y"
{ yyval.string = 0; }
break;
case 124:
#line 524 "moc.y"
{ yyval.string = yyvsp[0].string; }
break;
case 129:
#line 536 "moc.y"
{ tmpAccessPerm = yyvsp[0].access; }
break;
case 130:
#line 537 "moc.y"
{ moc_err( "Missing access specifier"
						   " before \"slots:\"." ); }
break;
case 131:
#line 541 "moc.y"
{ BEGIN QT_DEF; }
break;
case 133:
#line 543 "moc.y"
{ BEGIN QT_DEF; }
break;
case 135:
#line 545 "moc.y"
{ if ( tmpAccessPerm )
				moc_warn("Q_OBJECT is not in the private"
					" section of the class.\n"
					"Q_OBJECT is a macro that resets"
					" access permission to \"private\".");
						  Q_OBJECTdetected = TRUE; }
break;
case 136:
#line 553 "moc.y"
{ moc_err( "Signals cannot "
						 "have access specifiers" ); }
break;
case 138:
#line 556 "moc.y"
{ if ( grammarDebug )
						  BEGIN QT_DEF;
					      else
						  BEGIN IN_CLASS;
					 }
break;
case 140:
#line 562 "moc.y"
{ BEGIN IN_CLASS;
					   if ( level != 1 )
					       moc_warn( "unexpected access"
							 "specifier" );
					 }
break;
case 145:
#line 578 "moc.y"
{ addMember('s'); }
break;
case 150:
#line 589 "moc.y"
{ addMember('t'); }
break;
case 153:
#line 596 "moc.y"
{ yyval.string=yyvsp[0].string; }
break;
case 156:
#line 604 "moc.y"
{ yyval.string = stradd( yyvsp[-3].string, "(", yyvsp[-1].string, ")" ); }
break;
case 157:
#line 606 "moc.y"
{ yyval.string = stradd( yyvsp[-3].string, "(", yyvsp[-1].string, ")" ); }
break;
case 158:
#line 609 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 159:
#line 610 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 160:
#line 611 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 161:
#line 612 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 162:
#line 613 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 163:
#line 614 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 164:
#line 615 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 165:
#line 616 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 166:
#line 617 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 167:
#line 618 "moc.y"
{yyval.string=yyvsp[0].string;}
break;
case 168:
#line 621 "moc.y"
{ yyval.access=_PRIVATE; }
break;
case 169:
#line 622 "moc.y"
{ yyval.access=_PROTECTED; }
break;
case 170:
#line 623 "moc.y"
{ yyval.access=_PUBLIC; }
break;
case 214:
#line 675 "moc.y"
{ tmpFunc->type = yyvsp[-1].string;
						  tmpFunc->name = yyvsp[0].string; }
break;
case 215:
#line 678 "moc.y"
{ tmpFunc->type = "int";
						  tmpFunc->name = yyvsp[0].string;
				  if ( tmpFunc->name == className )
				      func_warn( "Constructors cannot be"
						 " signals or slots.");
						}
break;
case 216:
#line 685 "moc.y"
{
				       func_warn( "Destructors cannot be"
						  " signals or slots.");
						}
break;
case 217:
#line 691 "moc.y"
{   
						    char *tmp = 
							straddSpc(yyvsp[-4].string,yyvsp[-3].string,yyvsp[-2].string,yyvsp[-1].string);
						    tmpFunc->type = rmWS(tmp);
						    delete tmp;
						    tmpFunc->name = yyvsp[0].string; }
break;
case 218:
#line 698 "moc.y"
{ skipFunc = TRUE; }
break;
case 219:
#line 700 "moc.y"
{ tmpFunc->type =
						      straddSpc(yyvsp[-2].string,yyvsp[-1].string);
						  tmpFunc->name = yyvsp[0].string; }
break;
case 220:
#line 705 "moc.y"
{ tmpFunc->type =
						      straddSpc(yyvsp[-3].string,yyvsp[-2].string,yyvsp[-1].string);
						  tmpFunc->name = yyvsp[0].string; }
break;
case 221:
#line 709 "moc.y"
{ operatorError();    }
break;
case 222:
#line 711 "moc.y"
{ operatorError();    }
break;
case 223:
#line 714 "moc.y"
{ operatorError();    }
break;
case 224:
#line 716 "moc.y"
{ operatorError();    }
break;
case 225:
#line 719 "moc.y"
{ operatorError();    }
break;
case 227:
#line 724 "moc.y"
{ func_warn("Variable as signal or slot."); }
break;
case 228:
#line 727 "moc.y"
{ func_warn("Variable as signal or slot."); }
break;
case 229:
#line 729 "moc.y"
{ func_warn("Enum declaration as signal or"
					  " slot."); }
break;
case 233:
#line 739 "moc.y"
{ expLevel = 0; }
break;
case 235:
#line 741 "moc.y"
{ expLevel = 0; }
break;
case 238:
#line 746 "moc.y"
{ expLevel = 0; }
break;
case 240:
#line 751 "moc.y"
{BEGIN IN_FCT; fctLevel=1;}
break;
case 241:
#line 752 "moc.y"
{BEGIN QT_DEF; }
break;
#line 2432 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
